<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    variant: {
      type: String,
      required: false,
      default: '',
    },
    hasLoadingState: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  data() {
    return {
      loading: true,
    };
  },
  mounted() {
    // Let's wait until the window is loaded to ensure data in UserSegmentsMixin's beforeMount is available
    window.addEventListener('load', () => {
      this.loading = false;
    });
  },
});
</script>

<template>
  <section
    v-if="(!loading && hasLoadingState) || !hasLoadingState"
    class="customer-logos"
    :class="{ 'customer-logos--preserve-aspect-ratio': loading }"
  >
    <div class="customer-logos__companies slp-flex">
      <SlpTypography
        tag="h2"
        variant="body2"
        class="customer-logos__trusted-by"
      >
        <a
          v-if="data.text?.legend"
          :href="data.text.url"
          :data-ga-name="data.text.data_ga_name ?? data.text.legend"
          :data-ga-location="data.text.data_ga_location ?? 'body'"
          >{{ data.text.legend }}
        </a>
        <span v-else>{{ data.text }}</span>
      </SlpTypography>
      <a
        v-for="company in data.showcased_enterprises"
        :key="company.alt"
        :href="company.url"
        v-bind="{ id: company.id ? company.id : null }"
        :data-ga-name="company.alt"
        data-ga-location="body"
        :aria-label="company.link_label ? company.link_label : null"
        :class="`icon ${company.size}`"
      >
        <img
          class="customer-logos__company-icon"
          :class="variant"
          :src="company.image_url"
          :alt="company.alt ? company.alt : 'company logo'"
          preload
        />
      </a>
    </div>
  </section>
</template>

<style lang="scss" scoped>
.customer-logos {
  margin-top: $spacing-32;
  margin-bottom: $spacing-64;

  &__companies {
    display: flex;
    justify-content: center;
    flex-wrap: nowrap;
    align-items: center;
    position: relative;
    animation: items-fade 1s ease forwards;
    @media (min-width: $breakpoint-md) {
      justify-content: space-between;
    }

    a {
      width: 110px;
      margin: $spacing-8;
      flex: 0 1 110px;

      &-icon {
        max-width: 100%;
      }

      img {
        width: 100%;
        filter: grayscale(100%);
      }
      .white {
        width: 100%;
        filter: brightness(0) invert(1);
      }
      &.lg {
        flex: 0 1 170px;
      }
      &.sm {
        flex: 0 1 90px;
      }

      &#deutsche-telekom {
        text-align: center;
        img {
          width: 50px !important;
          text-align: center;
        }
      }
    }

    &-icon:hover {
      transform: scale(1.05);
      transition: all 0.2s ease-in-out;
    }
    @media (max-width: $breakpoint-sm) {
      & > :nth-child(7) {
        display: none;
      }
      & > :nth-child(8) {
        display: none;
      }
    }
  }

  &__trusted-by {
    &:deep a {
      color: $color-primary-200;
      padding: 0;
      margin: 0;
    }
  }

  @keyframes items-fade {
    0% {
      opacity: 0;
    }
    100% {
      opacity: 1;
    }
  }

  @media (max-width: $breakpoint-md) {
    margin: $spacing-48 0 $spacing-64 0;

    &__companies {
      flex-wrap: wrap;
    }

    &__trusted-by {
      width: 100%;
      text-align: center;
      margin-top: 0;
    }

    &__companies {
      a {
        width: 100px;
      }
    }
  }
  @media (min-width: $breakpoint-md) {
    margin-bottom: 96px;
  }
  @media (min-width: $breakpoint-lg) {
    margin-bottom: 112px;
  }
}
</style>
